/*
 * mbedWrapper
 * 
 * Written by p07gbar
 * 
 * This library allows the mbed and the console to communicate as a packeted serial port
 */

package mbed.mbedwrapper;


import mbed.adkPort.AdkPort;

import android.app.Activity;
import android.os.Bundle;
import android.text.Editable;
import android.text.method.ScrollingMovementMethod;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class MbedWrapperActivity extends Activity {

	TextView acclist;
	TextView console;
	TextView titleTxt;
	StringBuilder consolestr;
	Button sendBtn;
	EditText toSend;
	Editable toSendText;
	Button resetBtn;
	Button dropBtn;
	Button clearBtn;

	AdkPort mbed;


	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.main);
		mbed = new AdkPort(this);
		acclist = (TextView) findViewById(R.id.acclisttxt);
		console = (TextView) findViewById(R.id.consoletxt);
		clearBtn = (Button) findViewById(R.id.btnClear);
		consolestr = new StringBuilder("Console: \n\r");
		console.setMovementMethod(new ScrollingMovementMethod());
		
		
		
		Thread thread = new Thread(mbed);
		thread.start();

		String[] list = mbed.getList(this);
		for (int i = 0; i < list.length; i++) {
			writeToConsole(list[i] + "\n\r");
		}
		 
		mbed.attachOnNew(new AdkPort.MessageNotifier(){ 
			@Override
			public void onNew()
			{
				int av = mbed.available();
				byte[] buf = mbed.readB();

				String toAdd = new String(buf, 0, av);
				writeToConsole("Recived:" + toAdd + "\n\r");
			}
		});
		
		toSend = (EditText) findViewById(R.id.editText1);
		toSendText = (Editable) toSend.getText();
		sendBtn = (Button) findViewById(R.id.btnSend);
		sendBtn.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				// Perform action on click

				String sending = toSendText.toString();

				writeToConsole("\n\rSending: " + sending + " "
						+ sending.length() + "\n");
				mbed.sendString(sending);
				toSendText.clear();
			}
		});
		


		clearBtn.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				consolestr = new StringBuilder("");
				writeToConsole("Console:\n\r");

			}
		});
		

	}

	public void writeToConsole(String in) {

		consolestr.append(in);
		console.setText(consolestr.toString());

	}

	@Override
	public void onDestroy() {
		mbed.onDestroy(this);
		super.onDestroy();

	}

}